#ifndef lint
static char const 
yyrcsid[] = "$FreeBSD: src/usr.bin/yacc/skeleton.c,v 1.28 2000/01/17 02:04:06 bde Exp $";
#endif
#include <stdlib.h>
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYLEX yylex()
#define YYEMPTY -1
#define yyclearin (yychar=(YYEMPTY))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING() (yyerrflag!=0)
static int yygrowstack();
#define YYPREFIX "yy"
#line 2 "parser.y"
/*
** Copyright (c) 2001  Hughes Technologies Pty Ltd.  All rights
** reserved.  
**
** Terms under which this software may be used or copied are
** provided in the  specific license associated with this product.
**
** Hughes Technologies disclaims all warranties with regard to this 
** software, including all implied warranties of merchantability and 
** fitness, in no event shall Hughes Technologies be liable for any 
** special, indirect or consequential damages or any damages whatsoever 
** resulting from loss of use, data or profits, whether in an action of 
** contract, negligence or other tortious action, arising out of or in 
** connection with the use or performance of this software.
**
**
** $Id: parser.c,v 1.27 2001/12/04 03:46:30 bambi Exp $
**
*/

/*
** Module	: 
** Purpose	: 
** Exports	: 
** Depends Upon	: 
*/



/**************************************************************************
** STANDARD INCLUDES
**************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>

#include <config/config.h>
#ifdef HAVE_UNISTD_H
#  include <unistd.h>
#endif
#ifdef HAVE_STRING_H
#  include <string.h>
#endif


/**************************************************************************
** MODULE SPECIFIC INCLUDES
**************************************************************************/

#include "ember.h"

int	yylex();
void	yyerror();

extern	ember *emberScript;

/**************************************************************************
** YACC DEFINITION
**************************************************************************/

#line 79 "y.tab.c"
#define YYERRCODE 256
#define EXEC_PATH 257
#define HTML 258
#define HTML_START 259
#define HTML_END 260
#define COND_GE 261
#define COND_LE 262
#define COND_NE 263
#define COND_EQ 264
#define COND_GT 265
#define COND_LT 266
#define COND_RE 267
#define COND_AND 268
#define COND_OR 269
#define OP_AUTOADD 270
#define OP_AUTOSUB 271
#define OP_AUTOMUL 272
#define OP_AUTODIV 273
#define OP_INC 274
#define OP_DEC 275
#define OP_SHIFT_L 276
#define OP_SHIFT_R 277
#define OP_ADD 278
#define OP_SUB 279
#define OP_MUL 280
#define OP_DIV 281
#define OP_MOD 282
#define OP_AND 283
#define OP_OR 284
#define IF 285
#define ELSE 286
#define WHILE 287
#define BREAK 288
#define CONTINUE 289
#define RETURN 290
#define FUNCT 291
#define COUNT 292
#define EXISTS 293
#define LOAD 294
#define MOD_LOAD 295
#define L_BRACE 296
#define R_BRACE 297
#define L_BRACKET 298
#define R_BRACKET 299
#define L_SQUARE 300
#define R_SQUARE 301
#define ASSIGN 302
#define BANG 303
#define COMMA 304
#define SEMI_COLON 305
#define T_INT 306
#define T_UINT 307
#define T_TEXT 308
#define T_CHAR 309
#define T_REAL 310
#define T_MONEY 311
#define T_ARRAY 312
#define T_ASSOC 313
#define VAR 314
#define IDENT 315
#define LIT_TEXT 316
#define LIT_INT 317
#define LIT_REAL 318
#define LIT_NEG_INT 319
#define LIT_NEG_REAL 320
#define BAD_LEX 321
#define SHIFT_LEFT 322
#define SHIFT_RIGHT 323
const short yylhs[] = {                                        -1,
    3,    6,    0,    1,    1,    2,    2,    8,    2,    9,
    2,    4,    4,    4,   13,   10,   14,   14,   16,   16,
   15,   12,    5,   18,    5,   11,   11,   11,   21,   22,
   11,   11,   11,   11,   26,   11,   27,   11,   25,   28,
   28,   19,   19,   19,   19,   19,   19,   19,   19,   31,
   20,   30,   30,   32,   32,   34,   36,   23,   37,   38,
   24,   33,   33,   39,   39,   39,   40,   40,   40,   35,
   35,   29,   29,   29,   29,   42,   42,   42,   42,   42,
   42,   42,   42,   42,   42,   42,   47,   46,   45,   45,
   45,   44,   44,   48,   48,   43,   43,   43,   43,   43,
   43,   43,   43,   43,   41,   41,   41,   41,   41,   41,
   41,   17,   17,   17,   17,   17,   17,   17,   17,    7,
   49,   51,   49,   50,   50,
};
const short yylen[] = {                                         2,
    0,    0,    6,    0,    1,    0,    2,    0,    5,    0,
    5,    0,    6,    2,    0,    6,    0,    2,    0,    3,
    2,    0,    0,    0,    2,    0,    2,    3,    0,    0,
    5,    2,    2,    3,    0,    4,    0,    4,    4,    0,
    1,    3,    6,    6,    2,    2,    3,    3,    3,    0,
    5,    0,    2,    0,    3,    0,    0,   10,    0,    0,
    9,    2,    4,    3,    1,    2,    0,    2,    2,    0,
    4,    1,    3,    3,    2,    1,    1,    1,    1,    2,
    4,    1,    4,    4,    4,    6,    0,    5,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    3,
    0,    0,    3,    0,    1,
};
const short yydefred[] = {                                      0,
    5,    0,    1,    0,    0,    0,    0,    0,    0,  122,
    0,    0,    0,    0,    2,    0,    0,    7,    0,  125,
  120,    8,   10,   15,    0,   14,    0,  123,    0,    0,
    0,    3,    0,    0,    0,    0,    0,    0,    0,   22,
    0,    0,    0,    0,    0,    0,    9,   11,    0,   25,
    0,   35,   37,    0,    0,    0,    0,   45,   46,    0,
    0,    0,   27,    0,    0,    0,    0,   32,   33,    0,
    0,  115,  116,  112,  119,  117,  118,  113,  114,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   89,   91,
   90,   93,   92,    0,    0,    0,    0,   77,   76,   78,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   28,   50,   30,   34,    0,   16,    0,   18,
   21,    0,   80,    0,    0,    0,    0,    0,    0,    0,
   87,  109,  108,  110,  105,  107,  106,  111,  103,  104,
   96,   97,   98,   99,  100,  101,  102,    0,    0,   56,
    0,    0,   62,   75,   36,   38,    0,   39,    0,    0,
   13,    0,    0,    0,    0,    0,    0,   73,    0,    0,
    0,    0,    0,    0,    0,   69,   68,    0,    0,    0,
    0,   31,   60,   20,   81,    0,   85,   63,   84,   83,
    0,    0,    0,    0,    0,   53,   51,    0,    0,   88,
    0,    0,    0,   86,   57,   55,    0,    0,   61,    0,
   58,    0,    0,   71,
};
const short yydgoto[] = {                                       2,
    3,    8,    4,   15,   32,   25,   39,   29,   30,   17,
   40,   64,   31,   80,   81,  120,  125,   33,   41,   67,
   42,  163,   43,   44,   45,  101,  102,  104,   94,  181,
  162,  196,   95,  175,  211,  208,   46,  198,   96,  153,
  148,   97,  149,   98,   99,  100,  172,    0,   11,   21,
   19,
};
const short yysindex[] = {                                   -235,
    0,    0,    0, -232, -249, -300, -297, -241, -232,    0,
 -236, -272, -269, -242,    0, -241, -229,    0, -249,    0,
    0,    0,    0,    0,    0,    0, -233,    0, -232, -232,
 -220,    0, -233, -216, -218, -217, -213,  -17, -233,    0,
 -206, -214, -233, -233, -193, -173,    0,    0,   92,    0,
  193,    0,    0, -165, -165, -165, -165,    0,    0, -165,
 -165, -165,    0, -171, -233, -169, -174,    0,    0, -233,
 -166,    0,    0,    0,    0,    0,    0,    0,    0, -163,
 -167, -175,  200, -157,  135, -165, -226, -155,    0,    0,
    0,    0,    0,  302, -152, -230, -243,    0,    0,    0,
 -233, -233,  164, -143,  342,  342,  342,  342,  -70,  261,
  342, -241,    0,    0,    0,    0,  193,    0,   92,    0,
    0,   92,    0, -170, -142,  130, -137,  342, -165, -165,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, -165, -165,    0,
  193,  193,    0,    0,    0,    0, -186,    0, -139, -136,
    0, -165, -233, -132, -167, -131,  207,    0, -230,  320,
  270, -165,  342,  342, -127,    0,    0, -165, -165,  252,
 -128,    0,    0,    0,    0,  164,    0,    0,    0,    0,
 -126, -233,  342,  342, -165,    0,    0, -122,  311,    0,
 -121,  252, -233,    0,    0,    0, -120, -111,    0, -118,
    0, -233, -117,    0,
};
const short yyrindex[] = {                                     23,
    0,    0,    0,   45,    1,    0,    0,   54,   45,    0,
   12,    0,    0,    0,    0,   54,    0,    0,    1,    0,
    0,    0,    0,    0,   66,    0, -262,    0,   45,   45,
    0,    0,   58,    0,    0,    0,    0,    0,   60,    0,
    0,    0,   60,   60,    0,    0,    0,    0, -108,    0,
    0,    0,    0, -107,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   60,    0,    0,    0,    0,   60,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 -106,    0,    0,    0,    0,    0, -159,  -79,    0,    0,
    0,    0,    0, -255,    0, -105,  -32,    0,    0,    0,
   60,   60,    0,    0, -104, -109,  -90,  -89,    0,    0,
  -88,   54,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, -204,    0, -248,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  -80,   60,    0, -106,    0,    0,    0, -105,    0,
    0,  -80, -238,  121,    0,    0,    0,    0,    0,  -78,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, -262,  -82,  -77,    0,    0,    0,    0,    0,    0,
    0,  -78, -262,    0,    0,    0,    0,   34,    0,    0,
    0, -262,    0,    0,
};
const short yygindex[] = {                                      0,
    0,   50,    0,  -12,    0,    0,   -1,    0,    0,    0,
  -33,    0,    0,    0,  105,   73,  -44,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  -14,   67,
    0,   40,  -68,    0,    0,    0,    0,    0,    0,   74,
    0,  -81,    0,  159,    0,    0,    0,    0,  240,    0,
    0,
};
#define YYTABLESIZE 626
const short yytable[] = {                                      50,
  121,  123,    9,   26,   82,   63,   16,    9,   10,   68,
   69,  124,   65,   65,   16,   12,  127,    5,   13,   66,
   66,    1,    4,   20,   59,    5,    5,    9,    9,   64,
   64,  113,   22,   70,   26,   23,  116,  151,  152,  105,
  106,  107,  108,   65,    6,  109,  110,  111,  164,   14,
   66,   34,   29,   12,   35,   36,   37,   26,   18,   26,
   64,    6,    7,   65,   65,   23,   27,  155,  156,  129,
  126,  128,   24,  130,   82,   92,   93,   49,   47,   48,
   38,   51,  176,  177,   54,  187,   52,   53,  157,  139,
  140,  141,  142,  143,  144,  145,  146,  147,   65,  161,
   66,   82,   82,   82,   82,   82,   82,   82,   82,   82,
   16,   70,  168,   71,  170,  171,   82,   82,   82,   82,
   82,   82,   82,   82,   82,  112,   83,   84,  114,  182,
  115,  117,  103,  173,  174,  118,  119,   82,  121,   82,
  124,   82,  131,  166,   82,   82,  150,  180,   87,   88,
   89,   90,   91,   92,   93,  158,  167,  180,  201,   82,
   82,  169,  178,  193,  194,  179,  183,  185,  192,  207,
  197,  199,  200,  203,  210,  205,  209,  212,  213,  214,
  202,   79,   79,   79,   79,   79,   79,   79,   79,   79,
   17,   40,   19,   67,   41,   47,   79,   79,   79,   79,
   79,   79,   79,   79,   79,  139,  140,  141,  142,  143,
  144,  145,  146,  147,   48,   49,   42,   79,   52,   79,
   54,   79,   44,  165,   79,   79,  159,   43,   72,   72,
   72,   72,   72,   72,   72,   72,   72,  184,  191,   79,
   79,  206,  188,   72,   72,   72,   72,   72,   72,   72,
   72,   72,   55,   56,   57,  154,   58,   59,   28,  121,
  121,    0,    0,    0,   72,    0,   72,    0,   72,    0,
  124,   72,   72,    0,    0,    0,    0,    0,   60,    0,
    0,    4,   61,    0,   62,  121,    0,  121,  121,  121,
  121,  121,   70,    0,  121,  121,  124,  121,  124,  124,
  124,  124,  124,    0,    0,  124,  124,    4,  124,    4,
    4,    4,    4,    4,  121,  121,    4,    4,   70,    0,
   70,   70,   70,   70,   24,  124,  124,    0,    0,    6,
   70,    6,    6,    6,    6,    6,    4,    4,   12,    0,
   12,   12,   12,   12,   59,    0,   59,   70,   70,    0,
   24,    0,   24,   24,   24,   24,   26,    0,    6,    6,
    0,    0,    0,    0,    0,    0,    0,   12,   12,    0,
    0,    0,   29,    0,   29,    0,    0,    0,    0,   24,
   24,   74,   74,   74,   74,   74,   74,   74,   74,   74,
  132,  133,  134,  135,  136,  137,  138,   72,   73,   74,
   75,   76,   77,   78,   79,  139,  140,  141,  142,  143,
  144,  145,  146,  147,    0,    0,    0,   74,    0,   74,
    0,   74,    0,    0,   74,   74,   83,   84,  168,    0,
    0,    0,   85,    0,    0,    0,    0,   86,    0,    0,
   72,   73,   74,   75,   76,   77,   78,   79,   87,   88,
   89,   90,   91,   92,   93,   83,   84,    0,    0,    0,
    0,  103,    0,    0,    0,    0,    0,    0,    0,   72,
   73,   74,   75,   76,   77,   78,   79,   87,   88,   89,
   90,   91,   92,   93,   83,   84,    0,    0,    0,    0,
   85,   83,   84,    0,    0,   86,    0,  122,   83,   84,
    0,    0,    0,    0,  186,    0,   87,   88,   89,   90,
   91,   92,   93,   87,   88,   89,   90,   91,   92,   93,
   87,   88,   89,   90,   91,   92,   93,  139,  140,  141,
  142,  143,  144,  145,  146,  147,  139,  140,  141,  142,
  143,  144,  145,  146,  147,  139,  140,  141,  142,  143,
  144,  145,  146,  147,    0,  195,    0,    0,    0,    0,
    0,  160,  132,  133,  134,  135,  136,  137,  138,    0,
  190,    0,    0,    0,    0,    0,    0,  139,  140,  141,
  142,  143,  144,  145,  146,  147,  139,  140,  141,  142,
  143,  144,  145,  146,  147,  139,  140,  141,  142,  143,
  144,  145,  146,  147,    0,    0,    0,    0,    0,  204,
    0,    0,    0,    0,    0,    0,  189,  139,  140,  141,
  142,  143,  144,  145,  146,  147,
};
const short yycheck[] = {                                      33,
    0,   83,    4,   16,   49,   39,    8,    9,  258,   43,
   44,    0,  268,  269,   16,  316,   85,  259,  316,  268,
  269,  257,    0,  260,  287,  259,  259,   29,   30,  268,
  269,   65,  305,    0,  297,  305,   70,  268,  269,   54,
   55,   56,   57,  299,    0,   60,   61,   62,  117,  291,
  299,  285,  315,    0,  288,  289,  290,    0,    9,    0,
  299,  294,  295,  268,  269,    0,  296,  101,  102,  296,
   85,   86,  315,  300,  119,  319,  320,  298,   29,   30,
  314,  298,  151,  152,  298,  167,  305,  305,  103,  276,
  277,  278,  279,  280,  281,  282,  283,  284,  305,  112,
  315,  261,  262,  263,  264,  265,  266,  267,  268,  269,
  112,  305,  299,  287,  129,  130,  276,  277,  278,  279,
  280,  281,  282,  283,  284,  297,  292,  293,  298,  163,
  305,  298,  298,  148,  149,  299,  304,  297,  314,  299,
  298,  301,  298,  314,  304,  305,  299,  162,  314,  315,
  316,  317,  318,  319,  320,  299,  299,  172,  192,  319,
  320,  299,  302,  178,  179,  302,  299,  299,  296,  203,
  299,  186,  299,  296,  286,  297,  297,  296,  212,  297,
  195,  261,  262,  263,  264,  265,  266,  267,  268,  269,
  299,  299,  299,  299,  299,  305,  276,  277,  278,  279,
  280,  281,  282,  283,  284,  276,  277,  278,  279,  280,
  281,  282,  283,  284,  305,  305,  305,  297,  299,  299,
  299,  301,  305,  119,  304,  305,  297,  305,  261,  262,
  263,  264,  265,  266,  267,  268,  269,  165,  172,  319,
  320,  202,  169,  276,  277,  278,  279,  280,  281,  282,
  283,  284,  270,  271,  272,   97,  274,  275,   19,  259,
  260,   -1,   -1,   -1,  297,   -1,  299,   -1,  301,   -1,
  259,  304,  305,   -1,   -1,   -1,   -1,   -1,  296,   -1,
   -1,  259,  300,   -1,  302,  285,   -1,  287,  288,  289,
  290,  291,  259,   -1,  294,  295,  285,  297,  287,  288,
  289,  290,  291,   -1,   -1,  294,  295,  285,  297,  287,
  288,  289,  290,  291,  314,  315,  294,  295,  285,   -1,
  287,  288,  289,  290,  259,  314,  315,   -1,   -1,  285,
  297,  287,  288,  289,  290,  291,  314,  315,  285,   -1,
  287,  288,  289,  290,  287,   -1,  287,  314,  315,   -1,
  285,   -1,  287,  288,  289,  290,  297,   -1,  314,  315,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  314,  315,   -1,
   -1,   -1,  315,   -1,  315,   -1,   -1,   -1,   -1,  314,
  315,  261,  262,  263,  264,  265,  266,  267,  268,  269,
  261,  262,  263,  264,  265,  266,  267,  306,  307,  308,
  309,  310,  311,  312,  313,  276,  277,  278,  279,  280,
  281,  282,  283,  284,   -1,   -1,   -1,  297,   -1,  299,
   -1,  301,   -1,   -1,  304,  305,  292,  293,  299,   -1,
   -1,   -1,  298,   -1,   -1,   -1,   -1,  303,   -1,   -1,
  306,  307,  308,  309,  310,  311,  312,  313,  314,  315,
  316,  317,  318,  319,  320,  292,  293,   -1,   -1,   -1,
   -1,  298,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  306,
  307,  308,  309,  310,  311,  312,  313,  314,  315,  316,
  317,  318,  319,  320,  292,  293,   -1,   -1,   -1,   -1,
  298,  292,  293,   -1,   -1,  303,   -1,  298,  292,  293,
   -1,   -1,   -1,   -1,  298,   -1,  314,  315,  316,  317,
  318,  319,  320,  314,  315,  316,  317,  318,  319,  320,
  314,  315,  316,  317,  318,  319,  320,  276,  277,  278,
  279,  280,  281,  282,  283,  284,  276,  277,  278,  279,
  280,  281,  282,  283,  284,  276,  277,  278,  279,  280,
  281,  282,  283,  284,   -1,  304,   -1,   -1,   -1,   -1,
   -1,  301,  261,  262,  263,  264,  265,  266,  267,   -1,
  301,   -1,   -1,   -1,   -1,   -1,   -1,  276,  277,  278,
  279,  280,  281,  282,  283,  284,  276,  277,  278,  279,
  280,  281,  282,  283,  284,  276,  277,  278,  279,  280,
  281,  282,  283,  284,   -1,   -1,   -1,   -1,   -1,  299,
   -1,   -1,   -1,   -1,   -1,   -1,  297,  276,  277,  278,
  279,  280,  281,  282,  283,  284,
};
#define YYFINAL 2
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 323
#if YYDEBUG
const char * const yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"EXEC_PATH","HTML","HTML_START",
"HTML_END","COND_GE","COND_LE","COND_NE","COND_EQ","COND_GT","COND_LT",
"COND_RE","COND_AND","COND_OR","OP_AUTOADD","OP_AUTOSUB","OP_AUTOMUL",
"OP_AUTODIV","OP_INC","OP_DEC","OP_SHIFT_L","OP_SHIFT_R","OP_ADD","OP_SUB",
"OP_MUL","OP_DIV","OP_MOD","OP_AND","OP_OR","IF","ELSE","WHILE","BREAK",
"CONTINUE","RETURN","FUNCT","COUNT","EXISTS","LOAD","MOD_LOAD","L_BRACE",
"R_BRACE","L_BRACKET","R_BRACKET","L_SQUARE","R_SQUARE","ASSIGN","BANG","COMMA",
"SEMI_COLON","T_INT","T_UINT","T_TEXT","T_CHAR","T_REAL","T_MONEY","T_ARRAY",
"T_ASSOC","VAR","IDENT","LIT_TEXT","LIT_INT","LIT_REAL","LIT_NEG_INT",
"LIT_NEG_REAL","BAD_LEX","SHIFT_LEFT","SHIFT_RIGHT",
};
const char * const yyrule[] = {
"$accept : ember_script",
"$$1 :",
"$$2 :",
"ember_script : opt_exec_path $$1 opt_load function_definitions $$2 main_definitions",
"opt_exec_path :",
"opt_exec_path : EXEC_PATH",
"opt_load :",
"opt_load : html_content opt_load",
"$$3 :",
"opt_load : LOAD LIT_TEXT SEMI_COLON $$3 opt_load",
"$$4 :",
"opt_load : MOD_LOAD LIT_TEXT SEMI_COLON $$4 opt_load",
"function_definitions :",
"function_definitions : function_def L_BRACE ember_code retval R_BRACE function_definitions",
"function_definitions : html_content function_definitions",
"$$5 :",
"function_def : FUNCT IDENT $$5 L_BRACKET opt_function_args R_BRACKET",
"opt_function_args :",
"opt_function_args : function_arg opt_function_tail",
"opt_function_tail :",
"opt_function_tail : COMMA function_arg opt_function_tail",
"function_arg : type VAR",
"retval :",
"main_definitions :",
"$$6 :",
"main_definitions : $$6 ember_code",
"ember_code :",
"ember_code : html_content ember_code",
"ember_code : variable_assign SEMI_COLON ember_code",
"$$7 :",
"$$8 :",
"ember_code : $$7 function_call SEMI_COLON $$8 ember_code",
"ember_code : if_code_block ember_code",
"ember_code : while_code_block ember_code",
"ember_code : return SEMI_COLON ember_code",
"$$9 :",
"ember_code : BREAK SEMI_COLON $$9 ember_code",
"$$10 :",
"ember_code : CONTINUE SEMI_COLON $$10 ember_code",
"return : RETURN L_BRACKET opt_return_value R_BRACKET",
"opt_return_value :",
"opt_return_value : expr",
"variable_assign : VAR ASSIGN expr",
"variable_assign : VAR L_SQUARE expr R_SQUARE ASSIGN expr",
"variable_assign : VAR L_BRACE expr R_BRACE ASSIGN expr",
"variable_assign : VAR OP_INC",
"variable_assign : VAR OP_DEC",
"variable_assign : VAR OP_AUTOADD expr",
"variable_assign : VAR OP_AUTOSUB expr",
"variable_assign : VAR OP_AUTOMUL expr",
"$$11 :",
"function_call : IDENT L_BRACKET $$11 opt_param_list R_BRACKET",
"opt_param_list :",
"opt_param_list : expr opt_param_tail",
"opt_param_tail :",
"opt_param_tail : COMMA expr opt_param_tail",
"$$12 :",
"$$13 :",
"if_code_block : IF L_BRACKET condition R_BRACKET $$12 L_BRACE ember_code R_BRACE $$13 opt_else",
"$$14 :",
"$$15 :",
"while_code_block : $$14 WHILE L_BRACKET condition R_BRACKET $$15 L_BRACE ember_code R_BRACE",
"condition : cond_expr opt_cond_logic",
"condition : L_BRACKET condition R_BRACKET opt_cond_logic",
"cond_expr : expr cond_op expr",
"cond_expr : expr",
"cond_expr : BANG expr",
"opt_cond_logic :",
"opt_cond_logic : COND_OR condition",
"opt_cond_logic : COND_AND condition",
"opt_else :",
"opt_else : ELSE L_BRACE ember_code R_BRACE",
"expr : expr_value",
"expr : L_BRACKET expr R_BRACKET",
"expr : expr math_op expr",
"expr : expr_value neg_literal",
"expr_value : literal",
"expr_value : neg_literal",
"expr_value : function_value",
"expr_value : IDENT",
"expr_value : COUNT expr_value",
"expr_value : EXISTS L_BRACKET VAR R_BRACKET",
"expr_value : VAR",
"expr_value : VAR L_SQUARE expr R_SQUARE",
"expr_value : VAR L_BRACE expr R_BRACE",
"expr_value : L_BRACKET type R_BRACKET expr_value",
"expr_value : L_BRACKET type R_BRACKET L_BRACKET expr R_BRACKET",
"$$16 :",
"function_value : IDENT L_BRACKET $$16 opt_param_list R_BRACKET",
"literal : LIT_TEXT",
"literal : LIT_REAL",
"literal : LIT_INT",
"neg_literal : LIT_NEG_REAL",
"neg_literal : LIT_NEG_INT",
"all_literals : literal",
"all_literals : neg_literal",
"math_op : OP_ADD",
"math_op : OP_SUB",
"math_op : OP_MUL",
"math_op : OP_DIV",
"math_op : OP_MOD",
"math_op : OP_AND",
"math_op : OP_OR",
"math_op : OP_SHIFT_L",
"math_op : OP_SHIFT_R",
"cond_op : COND_EQ",
"cond_op : COND_LT",
"cond_op : COND_GT",
"cond_op : COND_LE",
"cond_op : COND_GE",
"cond_op : COND_NE",
"cond_op : COND_RE",
"type : T_TEXT",
"type : T_ARRAY",
"type : T_ASSOC",
"type : T_INT",
"type : T_UINT",
"type : T_REAL",
"type : T_MONEY",
"type : T_CHAR",
"html_content : HTML_START html_block opt_html_end",
"html_block :",
"$$17 :",
"html_block : HTML $$17 html_block",
"opt_html_end :",
"opt_html_end : HTML_END",
};
#endif
#ifndef YYSTYPE
typedef int YYSTYPE;
#endif
#if YYDEBUG
#include <stdio.h>
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH 10000
#endif
#endif
#define YYINITSTACKSIZE 200
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short *yyss;
short *yysslim;
YYSTYPE *yyvs;
int yystacksize;
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack()
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;
    i = yyssp - yyss;
    newss = yyss ? (short *)realloc(yyss, newsize * sizeof *newss) :
      (short *)malloc(newsize * sizeof *newss);
    if (newss == NULL)
        return -1;
    yyss = newss;
    yyssp = newss + i;
    newvs = yyvs ? (YYSTYPE *)realloc(yyvs, newsize * sizeof *newvs) :
      (YYSTYPE *)malloc(newsize * sizeof *newvs);
    if (newvs == NULL)
        return -1;
    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab

#ifndef YYPARSE_PARAM
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG void
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif	/* ANSI-C/C++ */
#else	/* YYPARSE_PARAM */
#ifndef YYPARSE_PARAM_TYPE
#define YYPARSE_PARAM_TYPE void *
#endif
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG YYPARSE_PARAM_TYPE YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL YYPARSE_PARAM_TYPE YYPARSE_PARAM;
#endif	/* ANSI-C/C++ */
#endif	/* ! YYPARSE_PARAM */

int
yyparse (YYPARSE_PARAM_ARG)
    YYPARSE_PARAM_DECL
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register const char *yys;

    if ((yys = getenv("YYDEBUG")))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate])) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#if defined(lint) || defined(__GNUC__)
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#if defined(lint) || defined(__GNUC__)
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
#line 151 "parser.y"
{
		eInit(emberScript);
	  }
break;
case 2:
#line 156 "parser.y"
{
		eInitMain(emberScript);
	  }
break;
case 3:
#line 160 "parser.y"
{
		eEndOfInput();
	  }
break;
case 8:
#line 173 "parser.y"
{
		if (eLoadLibrary(emberScript, yyvsp[-1]) < 0)
		{
			free(yyvsp[-1]);
			return(-1);
		}
		free(yyvsp[-1]);
	  }
break;
case 10:
#line 182 "parser.y"
{
		if (eDynLoadModule(emberScript, yyvsp[-1]) < 0)
		{
			free(yyvsp[-1]);
			return(-1);
		}
		free(yyvsp[-1]);
	  }
break;
case 15:
#line 198 "parser.y"
{
		if (eSymCreateFunction(emberScript, yyvsp[0]) < 0)
		{
			free(yyvsp[0]);
			return(-1);
		}
		free(yyvsp[0]);
	  }
break;
case 21:
#line 218 "parser.y"
{
		if (eSymAddFunctionArg(emberScript, yyvsp[0], (int)yyvsp[-1]) < 0)
		{
			free(yyvsp[0]);
			return(-1);
		}
		free(yyvsp[0]);
	}
break;
case 22:
#line 229 "parser.y"
{
		/*
		** Ensure that the last opcode we wrote was a return.  If
		** not then we'd better put one in there so that this
		** thing has a return value (even a default empty value)
		*/
		if (emberScript->info.curFunction->lastPcode == NULL ||
		    emberScript->info.curFunction->lastPcode->op != E_RETURN)
		{
			if (eCodePushLiteral(emberScript, EMBER_TYPE_TEXT, 
				"") < 0)
			{
				return(-1);
			}
		}
	  }
break;
case 24:
#line 249 "parser.y"
{
		emberScript->info.curFunction = &emberScript->main;
	  }
break;
case 29:
#line 264 "parser.y"
{ emberScript->info.ignoreReturn = EMBER_TRUE; }
break;
case 30:
#line 266 "parser.y"
{ emberScript->info.ignoreReturn = EMBER_FALSE; }
break;
case 35:
#line 272 "parser.y"
{
		int	label;

		label = eCodePopBreakLabel(emberScript);
		eCodeJMP(emberScript, label);
		eCodePushBreakLabel(emberScript, label);
	   }
break;
case 37:
#line 281 "parser.y"
{
		int	label;

		label = eCodePopContLabel(emberScript);
		eCodeJMPB(emberScript, label);
		eCodePushContLabel(emberScript, label);
	   }
break;
case 39:
#line 292 "parser.y"
{
		if (eCodeReturn(emberScript) < 0)
			return(-1);
	  }
break;
case 40:
#line 299 "parser.y"
{
		if (eCodePushLiteral(emberScript, EMBER_TYPE_TEXT, "") < 0)
		{
			return(-1);
		}
	  }
break;
case 42:
#line 310 "parser.y"
{
		e_stab	*symbol;
		int	varID;

		symbol = eSymGetVariableByName(emberScript,yyvsp[-2]);
		if (symbol == NULL)
			symbol = eSymCreateVariable(emberScript,yyvsp[-2]);
		if (symbol == NULL)
		{
			free(yyvsp[-2]);
			return(-1);
		}
		varID = symbol->id;
		if (eCodeStore(emberScript, varID) < 0)
		{
			free(yyvsp[-2]);
			return(-1);
		}
		free(yyvsp[-2]);
	  }
break;
case 43:
#line 332 "parser.y"
{
		e_stab	*symbol;
		int	varID;

		symbol = eSymGetVariableByName(emberScript,yyvsp[-5]);
		if (symbol == NULL)
			symbol = eSymCreateVariable(emberScript,yyvsp[-5]);
		if (symbol == NULL)
		{
			free(yyvsp[-5]);
			return(-1);
		}
		varID = symbol->id;
		if (eCodeArrayStore(emberScript, varID) < 0)
		{
			free(yyvsp[-5]);
			return(-1);
		}
		free(yyvsp[-5]);
	  }
break;
case 44:
#line 354 "parser.y"
{
		e_stab	*symbol;
		int	varID;

		symbol = eSymGetVariableByName(emberScript,yyvsp[-5]);
		if (symbol == NULL)
			symbol = eSymCreateVariable(emberScript,yyvsp[-5]);
		if (symbol == NULL)
		{
			free(yyvsp[-5]);
			return(-1);
		}
		varID = symbol->id;
		if (eCodeAssocStore(emberScript, varID) < 0)
		{
			free(yyvsp[-5]);
			return(-1);
		}
		free(yyvsp[-5]);
	  }
break;
case 45:
#line 376 "parser.y"
{
		e_stab	*symbol;
		int	varID;

		symbol = eSymGetVariableByName(emberScript,yyvsp[-1]);
		if (symbol == NULL)
		{
			symbol = eSymCreateVariable(emberScript,yyvsp[-1]);
		}
		varID = symbol->id;
		if (eCodePushVariable(emberScript, yyvsp[-1]) < 0)
		{
			free(yyvsp[-1]);
			return(-1);
		}
		if (eCodePushLiteral(emberScript, EMBER_TYPE_INT, "1") < 0)
		{
			free(yyvsp[-1]);
			return(-1);
		}
		if (eCodeAlu(emberScript,OP_ADD) < 0)
		{
			free(yyvsp[-1]);
			return(-1);
		}
		if (eCodeStore(emberScript, varID) < 0)
		{
			free(yyvsp[-1]);
			return(-1);
		}
		free(yyvsp[-1]);
	  }
break;
case 46:
#line 410 "parser.y"
{
		e_stab	*symbol;
		int	varID;

		symbol = eSymGetVariableByName(emberScript,yyvsp[-1]);
		if (symbol == NULL)
		{
			symbol = eSymCreateVariable(emberScript,yyvsp[-1]);
		}
		varID = symbol->id;
		if (eCodePushVariable(emberScript, yyvsp[-1]) < 0)
		{
			free(yyvsp[-1]);
			return(-1);
		}
		if (eCodePushLiteral(emberScript, EMBER_TYPE_INT, "1") < 0)
		{
			free(yyvsp[-1]);
			return(-1);
		}
		if (eCodeAlu(emberScript,OP_SUB) < 0)
		{
			free(yyvsp[-1]);
			return(-1);
		}
		if (eCodeStore(emberScript, varID) < 0)
		{
			free(yyvsp[-1]);
			return(-1);
		}
		free(yyvsp[-1]);
	  }
break;
case 47:
#line 444 "parser.y"
{
		e_stab	*symbol;
		int	varID;

		symbol = eSymGetVariableByName(emberScript,yyvsp[-2]);
		if (symbol == NULL)
		{
			symbol = eSymCreateVariable(emberScript,yyvsp[-2]);
		}
		varID = symbol->id;
		if (eCodePushVariable(emberScript, yyvsp[-2]) < 0)
		{
			free(yyvsp[-2]);
			return(-1);
		}
		if (eCodeAlu(emberScript,OP_ADD) < 0)
		{
			free(yyvsp[-2]);
			return(-1);
		}
		if (eCodeStore(emberScript, varID) < 0)
		{
			free(yyvsp[-2]);
			return(-1);
		}
		free(yyvsp[-2]);
	}
break;
case 48:
#line 473 "parser.y"
{
		e_stab	*symbol;
		int	varID;

		symbol = eSymGetVariableByName(emberScript,yyvsp[-2]);
		if (symbol == NULL)
		{
			symbol = eSymCreateVariable(emberScript,yyvsp[-2]);
		}
		varID = symbol->id;
		if (eCodePushVariable(emberScript, yyvsp[-2]) < 0)
		{
			free(yyvsp[-2]);
			return(-1);
		}
		if (eCodeAlu(emberScript,OP_SUB) < 0)
		{
			free(yyvsp[-2]);
			return(-1);
		}
		if (eCodeStore(emberScript, varID) < 0)
		{
			free(yyvsp[-2]);
			return(-1);
		}
		free(yyvsp[-2]);
	}
break;
case 49:
#line 502 "parser.y"
{
		e_stab	*symbol;
		int	varID;

		symbol = eSymGetVariableByName(emberScript,yyvsp[-2]);
		if (symbol == NULL)
		{
			symbol = eSymCreateVariable(emberScript,yyvsp[-2]);
		}
		varID = symbol->id;
		if (eCodePushVariable(emberScript, yyvsp[-2]) < 0)
		{
			free(yyvsp[-2]);
			return(-1);
		}
		if (eCodeAlu(emberScript,OP_MUL) < 0)
		{
			free(yyvsp[-2]);
			return(-1);
		}
		if (eCodeStore(emberScript, varID) < 0)
		{
			free(yyvsp[-2]);
			return(-1);
		}
		free(yyvsp[-2]);
	}
break;
case 50:
#line 533 "parser.y"
{
		if (eCodeBlockIn(emberScript) < 0)
		{
			free(yyvsp[-1]);
			return(-1);
		}
	  }
break;
case 51:
#line 541 "parser.y"
{
		if (eCodeCall(emberScript, yyvsp[-4], EMBER_TRUE) < 0)
		{
			free(yyvsp[-4]);
			return(-1);
		}
		if (eCodeBlockOut(emberScript) < 0)
		{
			free(yyvsp[-4]);
			return(-1);
		}
		free(yyvsp[-4]);
	  }
break;
case 56:
#line 566 "parser.y"
{
		int	elseLabel,
			endLabel;

		elseLabel = eCodeGetLabel(emberScript);
		endLabel = eCodeGetLabel(emberScript);
		eCodeJZ(emberScript,elseLabel);
		eCodePushLabel(emberScript,endLabel);
		eCodePushLabel(emberScript,elseLabel);
	  }
break;
case 57:
#line 577 "parser.y"
{
		int	elseLabel,
			endLabel;

		elseLabel = eCodePopLabel(emberScript);
		endLabel = elseLabel + 1;
		eCodeJMP(emberScript,endLabel);
		eCodeLabel(emberScript,elseLabel);
	  }
break;
case 58:
#line 587 "parser.y"
{
		int	endLabel;

		endLabel = eCodePopLabel(emberScript);
		eCodeLabel(emberScript,endLabel);
	  }
break;
case 59:
#line 596 "parser.y"
{
		int	startLabel;

		startLabel = eCodeGetLabel(emberScript);
		eCodeLabel(emberScript,startLabel);
		eCodePushLabel(emberScript, startLabel);
		eCodePushContLabel(emberScript, startLabel);
	  }
break;
case 60:
#line 605 "parser.y"
{
		int	endLabel;

		endLabel = eCodeGetLabel(emberScript);
		eCodeJZ(emberScript, endLabel);
		eCodePushLabel(emberScript, endLabel);
		eCodePushBreakLabel(emberScript, endLabel);
	  }
break;
case 61:
#line 614 "parser.y"
{
		int	startLabel,
			endLabel;

		endLabel = eCodePopLabel(emberScript);
		startLabel = eCodePopLabel(emberScript);
		eCodeJMPB(emberScript, startLabel);
		eCodeLabel(emberScript, endLabel);
		eCodePopBreakLabel(emberScript);
		eCodePopContLabel(emberScript);
	  }
break;
case 64:
#line 632 "parser.y"
{
		if (eCodeCMP(emberScript, (int)yyvsp[-1]) < 0)
			return(-1);
	  }
break;
case 65:
#line 637 "parser.y"
{
		if (eCodePushLiteral(emberScript, EMBER_TYPE_INT, "0") < 0)
			return(-1);
		if (eCodeCMP(emberScript, COND_NE) < 0)
			return(-1);
	  }
break;
case 66:
#line 644 "parser.y"
{
		if (eCodePushLiteral(emberScript, EMBER_TYPE_INT, "0") < 0)
			return(-1);
		if (eCodeCMP(emberScript, COND_EQ) < 0)
			return(-1);
	  }
break;
case 68:
#line 654 "parser.y"
{
		if (eCodeAlu(emberScript,OP_OR) < 0)
			return(-1);
	  }
break;
case 69:
#line 659 "parser.y"
{
		if (eCodeAlu(emberScript,OP_AND) < 0)
			return(-1);
	  }
break;
case 74:
#line 675 "parser.y"
{
		if (eCodeAlu(emberScript,(int)yyvsp[-1]) < 0)
			return(-1);
	  }
break;
case 75:
#line 680 "parser.y"
{
		/* Handle '$foo = $baa-1' i.e. no space after - */
		if (eCodeAlu(emberScript,(int)OP_ADD) < 0)
			return(-1);
	  }
break;
case 79:
#line 691 "parser.y"
{
		if (eCodePushMacro(emberScript, yyvsp[0]) < 0)
		{
			free(yyvsp[0]);
			return(-1);
		}
	  }
break;
case 80:
#line 699 "parser.y"
{
		if (eCodeCount(emberScript) < 0)
			return(-1);
	  }
break;
case 81:
#line 704 "parser.y"
{
		if (eCodeExists(emberScript, yyvsp[-1]) < 0)
		{
			free(yyvsp[-1]);
			return(-1);
		}
		free(yyvsp[-1]);
	  }
break;
case 82:
#line 713 "parser.y"
{
		if (eCodePushVariable(emberScript, yyvsp[0]) < 0)
		{
			free(yyvsp[0]);
			return(-1);
		}
		free(yyvsp[0]);
	  }
break;
case 83:
#line 722 "parser.y"
{
		if (eCodePushVariable(emberScript, yyvsp[-3]) < 0)
		{
			free(yyvsp[-3]);
			return(-1);
		}
		eCodeArrayDeref(emberScript);
		free(yyvsp[-3]);
	  }
break;
case 84:
#line 732 "parser.y"
{
		if (eCodePushVariable(emberScript, yyvsp[-3]) < 0)
		{
			free(yyvsp[-3]);
			return(-1);
		}
		eCodeAssocDeref(emberScript);
		free(yyvsp[-3]);
	  }
break;
case 85:
#line 742 "parser.y"
{
		if (eCodeTypeCast(emberScript, (int)yyvsp[-2]) < 0)
			return(-1);
	  }
break;
case 86:
#line 747 "parser.y"
{
		if (eCodeTypeCast(emberScript, (int)yyvsp[-4]) < 0)
			return(-1);
	  }
break;
case 87:
#line 754 "parser.y"
{
		if (eCodeBlockIn(emberScript) < 0)
		{
			free(yyvsp[-1]);
			return(-1);
		}
	  }
break;
case 88:
#line 762 "parser.y"
{
		if (eCodeCall(emberScript, yyvsp[-4], EMBER_FALSE) < 0)
		{
			free(yyvsp[-4]);
			return(-1);
		}
		if (eCodeBlockOut(emberScript) < 0)
		{
			free(yyvsp[-4]);
			return(-1);
		}
		free(yyvsp[-4]);
	  }
break;
case 89:
#line 779 "parser.y"
{
		if (eCodePushLiteral(emberScript, EMBER_TYPE_TEXT, yyvsp[0]) < 0)
		{
			free(yyvsp[0]);
			return(-1);
		}
		free(yyvsp[0]);
	  }
break;
case 90:
#line 788 "parser.y"
{
		if (eCodePushLiteral(emberScript, EMBER_TYPE_REAL, yyvsp[0]) < 0)
		{
			free(yyvsp[0]);
			return(-1);
		}
		free(yyvsp[0]);
	  }
break;
case 91:
#line 797 "parser.y"
{
		if (eCodePushLiteral(emberScript, EMBER_TYPE_INT, yyvsp[0]) < 0)
		{
			free(yyvsp[0]);
			return(-1);
		}
		free(yyvsp[0]);
	  }
break;
case 92:
#line 808 "parser.y"
{
		if (eCodePushLiteral(emberScript, EMBER_TYPE_REAL, yyvsp[0]) < 0)
			return(-1);
	  }
break;
case 93:
#line 813 "parser.y"
{
		if (eCodePushLiteral(emberScript, EMBER_TYPE_INT, yyvsp[0]) < 0)
			return(-1);
	  }
break;
case 96:
#line 824 "parser.y"
{ yyval = yyvsp[0]; }
break;
case 97:
#line 825 "parser.y"
{ yyval = yyvsp[0]; }
break;
case 98:
#line 826 "parser.y"
{ yyval = yyvsp[0]; }
break;
case 99:
#line 827 "parser.y"
{ yyval = yyvsp[0]; }
break;
case 100:
#line 828 "parser.y"
{ yyval = yyvsp[0]; }
break;
case 101:
#line 830 "parser.y"
{ yyval = yyvsp[0]; }
break;
case 102:
#line 831 "parser.y"
{ yyval = yyvsp[0]; }
break;
case 103:
#line 833 "parser.y"
{ yyval = yyvsp[0]; }
break;
case 104:
#line 834 "parser.y"
{ yyval = yyvsp[0]; }
break;
case 105:
#line 837 "parser.y"
{ yyval = yyvsp[0]; }
break;
case 106:
#line 838 "parser.y"
{ yyval = yyvsp[0]; }
break;
case 107:
#line 839 "parser.y"
{ yyval = yyvsp[0]; }
break;
case 108:
#line 840 "parser.y"
{ yyval = yyvsp[0]; }
break;
case 109:
#line 841 "parser.y"
{ yyval = yyvsp[0]; }
break;
case 110:
#line 842 "parser.y"
{ yyval = yyvsp[0]; }
break;
case 111:
#line 843 "parser.y"
{ yyval = yyvsp[0]; }
break;
case 112:
#line 846 "parser.y"
{ yyval = (YYSTYPE) EMBER_TYPE_TEXT; }
break;
case 113:
#line 847 "parser.y"
{ yyval = (YYSTYPE) EMBER_TYPE_ARRAY; }
break;
case 114:
#line 848 "parser.y"
{ yyval = (YYSTYPE) EMBER_TYPE_ASSOC; }
break;
case 115:
#line 849 "parser.y"
{ yyval = (YYSTYPE) EMBER_TYPE_INT; }
break;
case 116:
#line 850 "parser.y"
{ yyval = (YYSTYPE) EMBER_TYPE_UINT; }
break;
case 117:
#line 851 "parser.y"
{ yyval = (YYSTYPE) EMBER_TYPE_REAL; }
break;
case 118:
#line 852 "parser.y"
{ yyval = (YYSTYPE) EMBER_TYPE_MONEY; }
break;
case 119:
#line 853 "parser.y"
{ 
			  fprintf(stderr,
				"'char' is obsolete.  Use 'text' at line %d\n",
				emberScript->info.curLineNum);
			  yyval = (YYSTYPE) EMBER_TYPE_TEXT; 
		  	}
break;
case 122:
#line 867 "parser.y"
{
		e_funct *tmpFunct;
		tmpFunct = emberScript->info.curFunction;
		emberScript->info.curFunction = &emberScript->main;
		eCodeBlockIn(emberScript);
		eCodePushLiteral(emberScript, HTML, yyvsp[0]);
		eCodeCall(emberScript, "echo", EMBER_TRUE);
		eCodeBlockOut(emberScript);
		emberScript->info.curFunction = tmpFunct;
	}
break;
#line 1548 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
